state_menu = state_manager.newState()

state_menu.font = love.graphics.newImageFont('images/font.png', 'ABCDEFGHIJKLMNOPQRSTUVWXYZ')

function state_menu.load()
   love.graphics.setBackgroundColor(0, 175, 175)
   state_menu.title = { image = love.graphics.newImage('images/menu_title.png'), y = 20}
   state_menu.title.x = (love.window.getWidth() / 2) - (state_menu.title.image:getWidth() / 2)
   state_menu.buttons = {}
   state_menu.addButton('PLAY', 350)
   state_menu.addButton('EXIT', 420)
end
function state_menu.update(dt)
   state_menu.selectButton()
end
function state_menu.draw()
   love.graphics.draw(state_menu.title.image, state_menu.title.x, state_menu.title.y)
   for _, bv in pairs(state_menu.buttons) do
      if bv.selected then
         love.graphics.setColor(0, 255, 0)
      end
      love.graphics.print(bv.text, bv.x, bv.y)
      love.graphics.setColor(255, 255, 255)
   end
end
function state_menu.unload()
   state_menu.buttons = nil
end

function state_menu.mousepressed(x, y, button)
   state_menu.pushButton(x, y, button)
end

-----

function state_menu.addButton(text, y)
   table.insert(state_menu.buttons, {text = text, x = (love.window.getWidth() / 2) - (state_menu.font:getWidth(text) / 2), y = y, selected = false})
end
function state_menu.selectButton()
      local x, y = love.mouse.getPosition()
      for _, bv in pairs(state_menu.buttons) do
      if x >= bv.x and x <= bv.x + state_menu.font:getWidth(bv.text) and
         y >= bv.y and y <= bv.y + state_menu.font:getHeight(bv.text) then
         bv.selected = true
      else
         bv.selected = false
      end
   end
end
function state_menu.pushButton(x, y, button)
   for _, bv in pairs(state_menu.buttons) do
      if x >= bv.x and x <= bv.x + state_menu.font:getWidth(bv.text) and
         y >= bv.y and y <= bv.y + state_menu.font:getHeight(bv.text) then
         if bv.text == 'PLAY' then
            state_manager.push(state_game)
         elseif bv.text == 'EXIT' then
            state_manager.pop()
         end
      end
   end
end