timer = {}
function timer.load()

   timer.minutes       = 4
   timer.seconds       = 0
   timer.milliseconds  = 0
   timer.string = ''
   timer.tile_set = newTileSet('clock_font', 16, 20)
   timer.tile_set.addTileType('0',                              0, 0)
   timer.tile_set.addTileType('1', timer.tile_set.tile_width     , 0)
   timer.tile_set.addTileType('2', timer.tile_set.tile_width *  2, 0)
   timer.tile_set.addTileType('3', timer.tile_set.tile_width *  3, 0)
   timer.tile_set.addTileType('4', timer.tile_set.tile_width *  4, 0)
   timer.tile_set.addTileType('5', timer.tile_set.tile_width *  5, 0)
   timer.tile_set.addTileType('6', timer.tile_set.tile_width *  6, 0)
   timer.tile_set.addTileType('7', timer.tile_set.tile_width *  7, 0)
   timer.tile_set.addTileType('8', timer.tile_set.tile_width *  8, 0)
   timer.tile_set.addTileType('9', timer.tile_set.tile_width *  9, 0)
   timer.tile_set.addTileType(':', timer.tile_set.tile_width * 10, 0)
   timer.tile_set.batch:setBufferSize(4)
   timer.x = (love.window.getWidth() / 2) - (timer.tile_set.tile_width * 2)
   timer.y = 440
   timer.tick_sound = love.audio.newSource('sounds/timer_tick.mp3')
   timer.end_sound  = love.audio.newSource('sounds/timer_end.wav')
end
function timer.update(dt)
   if timer.isEnded() == false then
      timer.milliseconds = timer.milliseconds + dt
      if timer.milliseconds >= 1 then
         timer.milliseconds = 0
         timer.seconds = timer.seconds - 1
         if timer.seconds < 0 then
            timer.minutes = timer.minutes - 1
            timer.seconds = 59
         end
         
         if timer.minutes == 0 then
            if timer.seconds == 0 then
               timer.end_sound:stop()
               timer.end_sound:play()
            elseif timer.seconds < 6 then
               timer.tick_sound:stop()
               timer.tick_sound:play()
            end
         end
      end

      if timer.seconds > 9 then
         timer.string = timer.minutes .. ':' .. timer.seconds
      else
         timer.string = timer.minutes .. ':0' .. timer.seconds
      end
      timer.tile_set.batch:bind()
      timer.tile_set.batch:clear()
      for i = 1, #timer.string do
         timer.tile_set.batch:add(timer.tile_set.tile_types[string.sub(timer.string, i, i)], timer.x + ((i -1) * timer.tile_set.tile_width), timer.y)
      end
      timer.tile_set.batch:unbind()
   else
      timer.end_sound:stop()
      timer.end_sound:play()
      local got_longest = false
      
      for _, v in pairs(words.list) do
         if #v.word == words.longest and v.solved == true then
            got_longest = true
         end
      end
      
      if got_longest == true then
         state_manager.push(state_manager.newOKDialog('WORD WHACKED', 'Get ready for the next one!', 320, 130))
      else
         state_manager.push(state_manager.newOKDialog('GAME OVER', 'Have a better vocabulary next time.', 320, 130))
      end
   end
end
function timer.draw()
   if timer.minutes < 1 and timer.seconds < 6 then
      love.graphics.setColor(255,   0,  0)
   elseif timer.minutes < 1 then
      love.graphics.setColor(255, 130, 50)
   elseif timer.minutes < 2 then
      love.graphics.setColor(255, 255,  0)
   end
   timer.tile_set.draw()
   love.graphics.setColor(255, 255, 255)
end
function timer.unload()
   timer.x            = nil
   timer.y            = nil
   timer.minutes      = nil
   timer.seconds      = nil
   timer.milliseconds = nil
   timer.string       = nil
   timer.tile_set     = nil
end

---

function timer.isEnded()
   if timer.minutes > 0 or timer.seconds > 0 then
      return false
   else
      return true
   end
end